
-------------------------------------------------------------------------------
--! @file       GF2.vhd
--! @author     William Diehl
--! @brief      OMD GF2
--! @date       8 July 2016
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity GF2 is
port(
	x		:in std_logic_vector(255 downto 0);
	o		:out std_logic_vector(255 downto 0));
end GF2;

architecture dataflow of GF2 is
begin										  
	
	o <= (x(254 downto 0) & '0') when (x(255)='0') else 
             ((x(254 downto 0) & '0') xor 
				 (x"0000000000000000000000000000000000000000000000000000000000000425"));
						
end dataflow;
