
-------------------------------------------------------------------------------
--! @file       Sigma1.vhd
--! @author     William Diehl
--! @brief      OMD Sigma1
--! @date       8 July 2016
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity Sigma1 is
generic( 
	n 		: integer :=32 		-- size of basic operation
	);
port(
	x		:in std_logic_vector(n-1 downto 0);
	o		:out std_logic_vector(n-1 downto 0));
end Sigma1;

architecture dataflow of Sigma1 is
begin										  
			
	o <= (x(5 downto 0) & x(n-1 downto 6))
	xor (x(10 downto 0) & x(n-1 downto 11))
	xor (x(24 downto 0) & x(n-1 downto 25));
						
end dataflow;
