
-------------------------------------------------------------------------------
--! @file       csa.vhd
--! @author     William Diehl
--! @brief      OMD csa
--! @date       8 July 2016
-------------------------------------------------------------------------------

--Carry Save Adder


library ieee;
use ieee.std_logic_1164.all; 
use ieee.std_logic_unsigned.all;  

entity csa is

port(

	a		:in std_logic_vector(31 downto 0);
	b		:in std_logic_vector(31 downto 0);
	c		:in std_logic_vector(31 downto 0);
	d               :out std_logic_vector(31 downto 0)
	);

end csa;

architecture dataflow of csa is

signal ps : std_logic_vector(31 downto 0);
signal sc : std_logic_vector(31 downto 0); 

begin

	ps <= a xor b xor c;
	sc <= (a and b) or (a and c) or (b and c);
	d <= ps + (sc(30 downto 0) & '0');


end dataflow; 

