
-------------------------------------------------------------------------------
--! @file       sigma0_lower.vhd
--! @author     William Diehl
--! @brief      OMD sigma0_lower
--! @date       8 July 2016
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity sigma0_lower is
generic( 
	n 		: integer :=32 		-- size of basic operation
	);
port(
	x		:in std_logic_vector(n-1 downto 0);
	o		:out std_logic_vector(n-1 downto 0));
end sigma0_lower;

architecture dataflow of sigma0_lower is
begin										  
			
	o <= (x(6 downto 0) & x(n-1 downto 7))
	xor (x(17 downto 0) & x(n-1 downto 18))
	xor ("000" & x(n-1 downto 3));
						
end dataflow;
