
-------------------------------------------------------------------------------
--! @file       sigma1_lower.vhd
--! @author     William Diehl
--! @brief      OMD sigma1_lower
--! @date       8 July 2016
-------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity sigma1_lower is
generic( 
	n 		: integer :=32 		-- size of basic operation
	);
port(
	x		:in std_logic_vector(n-1 downto 0);
	o		:out std_logic_vector(n-1 downto 0));
end sigma1_lower;

architecture dataflow of sigma1_lower is
begin										  
			
	o <= (x(16 downto 0) & x(n-1 downto 17))
	xor (x(18 downto 0) & x(n-1 downto 19))
	xor ("0000000000" & x(n-1 downto 10));
						
end dataflow;
